---------------------------------------------------------------------------------------------------
--
-- Title       : clk_div
-- Design      : opb_clk_div
-- Author      : 
-- Company     : 
--
---------------------------------------------------------------------------------------------------
--
-- File        : clk_div.vhd
-- Generated   : Tue Sep 14 12:15:32 2004
-- From        : interface description file
-- By          : Itf2Vhdl ver. 1.20
--
---------------------------------------------------------------------------------------------------
--
-- Description : 
--
---------------------------------------------------------------------------------------------------

--{{ Section below this comment is automatically maintained
--   and may be overwritten
--{entity {clk_div} architecture {simple}}

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.std_logic_unsigned.all;

library UNISIM;
use unisim.all;

entity util_clkdiv is
	generic(c_div_factor: integer:=1
			);
	 port(
		 clk : in STD_LOGIC;
		 clk_div_out : out STD_LOGIC
	     );
end util_clkdiv;


architecture simple of util_clkdiv is

component ROC -- reset on Configuration
  port (O : out std_logic);
end component;
component CLKDLL
    generic (
              -- TimingChecksOn    : boolean := False;
              -- InstancePath : STRING := "*";
              -- Xon               : boolean := TRUE;
              -- MsgOn             : boolean := False;
--             tipd_CLKIN   : VitalDelayType01 := (0.000 ns, 0.000 ns);
--             tipd_CLKFB   : VitalDelayType01 := (0.000 ns, 0.000 ns);
--             tipd_RST     : VitalDelayType01 := (0.000 ns, 0.000 ns);
--
--             tpd_CLKIN_LOCKED  : VitalDelayType01 := (0.000 ns, 0.000 ns);
--
--             tperiod_CLKIN_POSEDGE     : VitalDelayType  := 0.000 ns;
--             MAXPERCLKIN       : time := 1000000 ps;
--
--             tpw_CLKIN_posedge : VitalDelayType  := 0.000 ns;
--             tpw_CLKIN_negedge : VitalDelayType  := 0.000 ns;
--
--             tpw_RST_posedge   : VitalDelayType  := 0.000 ns;

--             FACTORY_JF : bit_vector := X"C080";
--             STARTUP_WAIT : boolean := false;
             DUTY_CYCLE_CORRECTION : boolean := TRUE;
             CLKDV_DIVIDE : real := 2.0);
    port (
          CLK0    : out std_ulogic := '0';
          CLK180  : out std_ulogic := '0';
          CLK270  : out std_ulogic := '0';
          CLK2X   : out std_ulogic := '0';
          CLK90   : out std_ulogic := '0';
          CLKDV   : out std_ulogic := '0';
          LOCKED  : out std_ulogic := '0';
          CLKFB   : in  std_ulogic := '0';
          CLKIN   : in  std_ulogic := '0';
          RST     : in  std_ulogic := '0'
      );
end component;

component BUFG
--   generic(
--      TimingChecksOn: Boolean := TRUE;
--      InstancePath: STRING := "*";
--      Xon: Boolean := True;
--      MsgOn: Boolean := False);
--      tpd_I_O                        :	VitalDelayType01 := (0.100 ns, 0.100 ns);
--      tipd_I                         :	VitalDelayType01 := (0.000 ns, 0.000 ns));

   port(
      O                              :	out   STD_ULOGIC;
      I                              :	in    STD_ULOGIC);
 end component;

function log2(arg: integer) return integer is
  begin
   for i in 1 to 32 loop
	  if 2**i <= arg then
		  return i;
	  end if;
	end loop;
	return -1;
end log2;

constant count_width: integer:= log2(c_div_factor);
signal count: std_logic_vector(count_width-1 downto 0);
signal arst: std_logic;
signal clk_div: std_logic;
begin


  g1: if c_div_factor < 2 generate -- no division
    clk_div_out<= clk;
  end generate;
  
  g2: if c_div_factor>=2 generate  -- with clock division
    clk_div<= count(count_width-1); -- the MSB of the counter
    b: BUFG
     port map (O=> clk_div_out,
       I=> clk_div);

    process(clk, arst)
    begin
    	if arst='1' then
    		count <=(others=>'0');
    	elsif rising_edge(clk) then
        if c_div_factor/=2 and c_div_factor/=4 and c_div_factor/=8 and c_div_factor/=16 and c_div_factor/=32 
          and count= c_div_factor-1 then
          count<= (others => '0');
        else
    		  count <= count + 1;
    	  end if;
      end if;
    end process;
    
    global_reset:
     ROC port map (O=> arst);
	end generate;							 


end simple;
